package xyz.lychee.lagfixer.libs.adventure.translation;

import java.text.MessageFormat;
import java.util.Locale;
import xyz.lychee.lagfixer.libs.adventure.key.Key;
import xyz.lychee.lagfixer.libs.adventure.text.Component;
import xyz.lychee.lagfixer.libs.adventure.text.TranslatableComponent;
import xyz.lychee.lagfixer.libs.adventure.util.TriState;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public interface Translator {
   static @Nullable Locale parseLocale(final @NotNull String string) {
      String[] segments = string.split("_", 3);
      int length = segments.length;
      if (length == 1) {
         return new Locale(string);
      } else if (length == 2) {
         return new Locale(segments[0], segments[1]);
      } else {
         return length == 3 ? new Locale(segments[0], segments[1], segments[2]) : null;
      }
   }

   @NotNull Key name();

   default @NotNull TriState hasAnyTranslations() {
      return TriState.NOT_SET;
   }

   @Nullable MessageFormat translate(final @NotNull String key, final @NotNull Locale locale);

   default @Nullable Component translate(final @NotNull TranslatableComponent component, final @NotNull Locale locale) {
      return null;
   }
}
